//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 Orange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

extern string  TimeFrame = "Current time frame";
extern int     price     = PRICE_CLOSE;
extern int     period    = 9;
extern int     histper   = 30;

double VIDYA[];
double VIDYAda[];
double VIDYAdb[];
double slope[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,VIDYA);   SetIndexLabel(0, "VIDYA"); SetIndexDrawBegin(0, histper);
   SetIndexBuffer(1,VIDYAda); SetIndexLabel(1, "VIDYA"); SetIndexDrawBegin(1, histper);
   SetIndexBuffer(2,VIDYAdb); SetIndexLabel(2, "VIDYA"); SetIndexDrawBegin(2, histper);
   SetIndexBuffer(3,slope);
   
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+" Vidya");
   return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { VIDYA[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               if (slope[limit]==-1) CleanPoint(limit,VIDYAda,VIDYAdb);
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);              
                     slope[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",price,period,histper,3,y);
                     VIDYA[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",price,period,histper,0,y);
                     VIDYAda[i] = EMPTY_VALUE;
                     VIDYAdb[i] = EMPTY_VALUE;
                        if (slope[i]==-1) PlotPoint(i,VIDYAda,VIDYAdb,VIDYA);  
               }
               return(0);
            }

   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,VIDYAda,VIDYAdb);
   for (i=limit; i>=0; i--)
   {
      double tprice = iMA(NULL,0,1,0,MODE_SMA,price,i);
      if (i < Bars - histper)
      {
         double k =  iStdDev(NULL, 0, period, 0, MODE_SMA, PRICE_CLOSE, i) / iStdDev(NULL, 0, histper, 0, MODE_SMA, PRICE_CLOSE, i);
         double sc = (2.0 / (period + 1));
         VIDYA[i] = k * sc * tprice + (1 - k * sc) * VIDYA[i+1];
      } 
      else  VIDYA[i] = tprice;
            VIDYAda[i] = EMPTY_VALUE;
            VIDYAdb[i] = EMPTY_VALUE;
            slope[i]   = slope[i+1];
               if (VIDYA[i]>VIDYA[i+1]) slope[i] =  1;
               if (VIDYA[i]<VIDYA[i+1]) slope[i] = -1;
               if (slope[i]==-1) PlotPoint(i,VIDYAda,VIDYAdb,VIDYA);  
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str) { string s = str; StringToUpper(s); return(s); }

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}